unit UVerwaltung;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, UTreeNode, UEingabe, UText;

type
  TFVerwaltung = class(TForm)
    BtGrundwissen: TButton;
    BtRaten: TButton;
    ListBox1: TListBox;
    BtSpeichern: TButton;
    BtLaden: TButton;
    SaveDlg: TSaveDialog;
    OpenDlg: TOpenDialog;
    procedure FormCreate(Sender: TObject);
    procedure BtRatenClick(Sender: TObject);
    procedure BtGrundwissenClick(Sender: TObject);
    procedure BtSpeichernClick(Sender: TObject);
    procedure BtLadenClick(Sender: TObject);
  private
    wissensbaum :TTreeNode;
    eingabe :TFeingabe;
    baumdatei:Textfile;
    procedure KnotenAnzeigen (AktKnoten:TTreeNode; Tiefe:integer; marker:string);
    procedure rate(knoten:TTreeNode);
    procedure neuenNamenEinlesen (Knoten :TTreeNode);
    procedure Speichere(node:TTreeNode);
    procedure lade(node:TTreeNode);
    procedure speichern(datname:String);
    procedure laden(datname:String);
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  FVerwaltung: TFVerwaltung;

implementation

{$R *.DFM}
procedure TFVerwaltung.KnotenAnzeigen (AktKnoten :TTreeNode;
                                     Tiefe     :integer;
                                     marker    :string);
var i: integer;
    Leer: string;
    Inhalt: TText;
begin
 if not (AktKnoten.isempty)
    then begin
      KnotenAnzeigen (AktKnoten.ReadRightNode,Tiefe+10,'n: ');
      Leer := '';
      For i := 1 to Tiefe do
        Leer := Leer + '  ';
      Listbox1.items.add (leer+marker+TText(AktKnoten.ReadValue).GetText);
      KnotenAnzeigen (AktKnoten.ReadLeftNode,Tiefe+10,'j: ');
    end
end;

procedure TFVerwaltung.rate(knoten:TTreeNode);
var mldg,alterName : String;
begin
if not (knoten.isempty) then
   if knoten.isLeaf then
      begin
        alterName:=TText(knoten.ReadValue).GetText;
        mldg := 'Handelt es sich um '+ alterName;
        mldg := mldg+' ?';
        if MessageDlg(mldg, mtInformation, [mbYes, mbNo], 0) = mrYes
        then
           MessageDlg
           ('Da siehst Du, wie  i n t e l l i g e n t  Computer sind!!',
            mtInformation,[mbok],0)
        else
           neuenNamenEinlesen(knoten)
      end
   else (*in der Mitte des Baumes *)
       if MessageDlg(TText(knoten.Readvalue).GetText,
           mtInformation, [mbYes, mbNo], 0) = mrYes
        then rate (knoten.ReadLeftNode)
        else rate (knoten.ReadRightNode)
end;

procedure TFVerwaltung.neuenNamenEinlesen (Knoten :TTreeNode);
var mldg,neuerName,alterName,neueFrage : String;
    KnotenAltLehrer,KnotenNeuLehrer : TTreeNode;
    inhalt:TText;
begin
   alterName := TText(Knoten.ReadValue).GetText;
             eingabe:=TFeingabe.create(FVerwaltung);
             eingabe.label1.caption:='';
             eingabe.label2.caption:='Wie heit die/der Lehrer/in,'+
                                     'den/die ich nicht erraten habe?' ;
             eingabe.showmodal;
   neuerName:=eingabe.getinhalt;

             eingabe:=TFeingabe.create(FVerwaltung);
             eingabe.label1.caption :=
                              'Gib bitte eine Frage ein, welche die Personen';
             eingabe.label2.caption:=
                               altername +' und '+neuerName+' unterscheidet!';
             eingabe.showmodal;
   neueFrage:=eingabe.getinhalt;

   {      Hier mss aus den Strings alterName, neuerName und neueFrage
          zuerst Textobjekte gemacht werden. Siehe Aufgabenteil 1a) .
          Danach sind dann passende Knotenobjekte zu erzeugen und in
          Abhngigkeit von der hier folgenden Frage passend anzuhngen.
          Siehe auch hier Aufgabenteil 1a).

          KnotenAltLehrer :=
          KnotenNeuLehrer :=      }

             mldg := 'Mu die Frage '+neueFrage;
             mldg := mldg + ' fr '+neuername+' mit  JA   beantwortet werden??';
             if MessageDlg(mldg, mtInformation, [mbYes, mbNo], 0) = mrYes then
                begin
                   {passend anhngen}
                end
              else
                begin
                   {passend anhngen}
                end;
             Listbox1.items.add('--------------------------------------------');
             KnotenAnzeigen(wissensbaum,0,'')
end; (* of proc neuenNamenEinlesen *)

procedure TFVerwaltung.Speichere(node:TTreeNode);
     var
       S:String;
     begin
       if not node.isEmpty then
       begin
        S:=TText(node.ReadValue).getText;
        if node.isLeaf then
          S:='#'+S;
        writeln(BaumDatei,S);
        showmessage('Gespeichert : '+s);
        Speichere(node.ReadLeftNode);
        Speichere(node.ReadRightNode)
      end
    end;

procedure TFVerwaltung.speichern;
  begin
    AssignFile(Baumdatei, datname);
    rewrite(BaumDatei);
    speichere(wissensbaum);
    closeFile(Baumdatei);
  end;

procedure TFVerwaltung.lade(node:TTreeNode);
    var
      t:string;
      Blatt:boolean;
    begin
      if not eof(BaumDatei) then begin
         readln(BaumDatei,t);
         showmessage('Laden: '+t);
         if t[1]='#' then
            begin
              Delete(t,1,1);
              Blatt:=true
            end
         else
           Blatt:=false;
        node.writevalue(TText.create(t));
        if not Blatt then begin
           lade(node.readLeftNode);
           lade(node.readRightNode)
         end
   end
end;

procedure TFVerwaltung.laden(datname:String);
  begin
      AssignFile(Baumdatei, datname);
      reset(Baumdatei);
    wissensbaum.destroy;
    wissensbaum:=TTreenode.createnil;
    lade(wissensbaum);
    closefile(baumdatei);
  end;

procedure TFVerwaltung.FormCreate(Sender: TObject);
var inhalt:TText;
    lKnoten,rKnoten:TTreeNode;
begin
    inhalt := TText.create('Ist es eine Lehrerin ??');
    wissensbaum := TTreeNode.create(inhalt);

    inhalt := TText.create('Frau Dreseler');
    lKnoten := TTreeNode.create(inhalt);
    wissensbaum.WriteLeftNode(lKnoten);
    (* oder kurz aber unbersichtlich:
    wissensbaum.WriteLeftNode (TTreeNode.Create(TText.Create('Frau D..')));  *)

    (***************** Hier gehrt die Ergnzung zu Aufg 1a) hin *************)

    KnotenAnzeigen(wissensbaum,0,'')
end;

procedure TFVerwaltung.BtRatenClick(Sender: TObject);
begin
   rate(wissensbaum)
end;

procedure TFVerwaltung.BtGrundwissenClick(Sender: TObject);
begin
  wissensbaum.free;
  Listbox1.items.clear;
  FormCreate(sender)
end;

procedure TFVerwaltung.BtSpeichernClick(Sender: TObject);
begin
  if SaveDlg.Execute then              { Dialog zum Dateiffnen anzeigen }
  begin
    speichern(SaveDlg.FileName)
  end;
end;

procedure TFVerwaltung.BtLadenClick(Sender: TObject);
begin
  if OpenDlg.Execute then              { Dialog zum Dateiffnen anzeigen }
  begin
    laden(OpenDlg.FileName);
    Listbox1.items.add('------------------------');
    KnotenAnzeigen(wissensbaum,0,'')
  end;
end;

end.
