unit UVerwaltung;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, UTreeNode, UEingabe, UText;

type
  TFVerwaltung = class(TForm)
    BtGrundwissen: TButton;
    BtRaten: TButton;
    ListBox1: TListBox;
    BtSpeichern: TButton;
    BtLaden: TButton;
    SaveDlg: TSaveDialog;
    OpenDlg: TOpenDialog;
    procedure FormCreate(Sender: TObject);
    procedure BtRatenClick(Sender: TObject);
    procedure BtGrundwissenClick(Sender: TObject);
    procedure BtSpeichernClick(Sender: TObject);
    procedure BtLadenClick(Sender: TObject);
  private
    wissensbaum :TTreeNode;
    eingabe :TFeingabe;
    baumdatei:Textfile;
    procedure BaumAnzeigen (AktKnoten:TTreeNode; Tiefe:integer; marker:string);
    procedure rate(baum:TTreeNode);
    procedure neuenNamenEinlesen (baum :TTreeNode);
    procedure Speichere(node:TTreeNode);
    procedure lade(node:TTreeNode);
    procedure speichern(datname:String);
    procedure laden(datname:String);
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  FVerwaltung: TFVerwaltung;

implementation

{$R *.DFM}
procedure TFVerwaltung.BaumAnzeigen (AktKnoten:TTreeNode; Tiefe:integer;
                                 marker:string);
var i: integer;
    Leer: string;
    Inhalt: TText;
begin
 if not (AktKnoten.isempty)
    then begin
      BaumAnzeigen (AktKnoten.ReadRightNode,Tiefe+10,'n: ');
      Leer := '';
      For i := 1 to Tiefe do
        Leer := Leer + '  ';
      Listbox1.items.add (leer+marker+TText(AktKnoten.ReadValue).GetText);
      BaumAnzeigen (AktKnoten.ReadLeftNode,Tiefe+10,'j: ');
    end
end;

procedure TFVerwaltung.rate(baum:TTreeNode);
var mldg,alterName : String;
begin
if not (baum.ReadValue=nil) then
   if baum.isLeaf then
      begin
        alterName:=TText(baum.ReadValue).GetText;
        mldg := 'Handelt es sich um '+ alterName;
        mldg := mldg+' ?';
        if MessageDlg(mldg, mtInformation, [mbYes, mbNo], 0) = mrYes
        then
           MessageDlg('Da siehst Du, wie  i n t e l l i g e n t  Computer sind!!',mtInformation,[mbok,mbcancel],0)
        else
           neuenNamenEinlesen(baum)
      end
   else (*in der Mitte des Baumes *)
       if MessageDlg(TText(baum.Readvalue).GetText,
           mtInformation, [mbYes, mbNo], 0) = mrYes
        then rate (baum.ReadLeftNode)
        else rate (baum.ReadRightNode)
end;

procedure TFVerwaltung.neuenNamenEinlesen (baum :TTreeNode);
var mldg,neuerName,alterName,neueFrage : String;
    baumAlt,baumNeu : TTreeNode;
    inhalt:TText;
begin
   alterName := TText(baum.ReadValue).GetText;
             eingabe:=TFeingabe.create(FVerwaltung);
             eingabe.label1.caption:='';
             eingabe.label2.caption:='Wie heit die/der Lehrer/in,'+
                                     'den/die ich nicht erraten habe?' ;
             eingabe.showmodal;
             neuerName:=eingabe.getinhalt;

             eingabe:=TFeingabe.create(FVerwaltung);
             eingabe.label1.caption :=
                              'Gib bitte eine Frage ein, welche die Personen';
             eingabe.label2.caption:=
                               altername +' und '+neuerName+' unterscheidet!';
             eingabe.showmodal;
             neueFrage:=eingabe.getinhalt;

             inhalt:=TText.create(neueFrage);
             baum.writevalue(inhalt);

             inhalt:=TText.create(altername);
             baumAlt := TTreeNode.create(inhalt);

             inhalt:=TText.create(neuername);
             baumNeu := TTreeNode.create(inhalt);

             mldg := 'Mu die Frage '+neueFrage;
             mldg := mldg + ' fr '+neuername+' mit  JA   beantwortet werden??';
             if MessageDlg(mldg, mtInformation, [mbYes, mbNo], 0) = mrYes then
                begin
                   baum.WriteLeftNode(baumNeu);
                   baum.WriteRightNode(baumAlt)
                end
              else
                begin
                   baum.WriteLeftNode(baumAlt);
                   baum.WriteRightNode(baumNeu)
                end;
             Listbox1.items.add('------------------------');
             BaumAnzeigen(wissensbaum,0,'')
end; (* of proc neuenNamenEinlesen *)

procedure TFVerwaltung.Speichere(node:TTreeNode);
     var
       S:String;
     begin
       if not node.isEmpty then
       begin
        S:=TText(node.ReadValue).getText;
        if node.isLeaf then
          S:='#'+S;
        writeln(BaumDatei,S);
        showmessage('Gespeichert : '+s);
        Speichere(node.ReadLeftNode);
        Speichere(node.ReadRightNode)
      end
    end;

procedure TFVerwaltung.speichern;
  begin
    AssignFile(Baumdatei, datname);
    rewrite(BaumDatei);
    speichere(wissensbaum);
    closeFile(Baumdatei);
  end;

procedure TFVerwaltung.lade(node:TTreeNode);
    var
      t:string;
      Blatt:boolean;
    begin
      if not eof(BaumDatei) then begin
         readln(BaumDatei,t);
         showmessage('Laden: '+t);
         if t[1]='#' then
            begin
              Delete(t,1,1);
              Blatt:=true
            end
         else
           Blatt:=false;
        node.writevalue(TText.create(t));
        if not Blatt then begin
           lade(node.readLeftNode);
           lade(node.readRightNode)
         end
   end
end;

procedure TFVerwaltung.laden(datname:String);
  begin
      AssignFile(Baumdatei, datname);
      reset(Baumdatei);
    wissensbaum.destroy;
    wissensbaum:=TTreenode.createnil;
    lade(wissensbaum);
    closefile(baumdatei);
  end;

procedure TFVerwaltung.FormCreate(Sender: TObject);
var inhalt:TText;
    lbaum,rbaum:TTreeNode;
begin
    inhalt := TText.create('Ist es eine Lehrerin ??');
    wissensbaum := TTreeNode.create(inhalt);

    inhalt := TText.create('Frau Dreseler');
    lbaum := TTreeNode.create(inhalt);
    wissensbaum.WriteLeftNode(lbaum);

    inhalt := TText.create('Herr Kubitz');
    rbaum := TTreeNode.create(inhalt);
    wissensbaum.WriteRightNode(rbaum);
    BaumAnzeigen(wissensbaum,0,'')
end;

procedure TFVerwaltung.BtRatenClick(Sender: TObject);
begin
   rate(wissensbaum)
end;

procedure TFVerwaltung.BtGrundwissenClick(Sender: TObject);
begin
  wissensbaum.free;
  Listbox1.items.clear;
  FormCreate(sender)
end;

procedure TFVerwaltung.BtSpeichernClick(Sender: TObject);
begin
  if SaveDlg.Execute then              { Dialog zum Dateiffnen anzeigen }
  begin
    speichern(SaveDlg.FileName)
  end;
end;

procedure TFVerwaltung.BtLadenClick(Sender: TObject);
begin
  if OpenDlg.Execute then              { Dialog zum Dateiffnen anzeigen }
  begin
    laden(OpenDlg.FileName);
    Listbox1.items.add('------------------------');
    BaumAnzeigen(wissensbaum,0,'')
  end;
end;

end.
