unit UVerwaltung;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, UBinTree, UTreeNode,UEingabe, UText;

type
  TFVerwaltung = class(TForm)
    BtGrundwissen: TButton;
    BtRaten: TButton;
    ListBox1: TListBox;
    procedure FormCreate(Sender: TObject);
    procedure BtRatenClick(Sender: TObject);
    procedure BtGrundwissenClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    wissensbaum :TBinTree;
    eingabe :TFeingabe;
    procedure BaumAnzeigen (AktKnoten:TTreeNode; Tiefe:integer; marker:string);
    procedure rate(baum:TBinTree);
    procedure neuenNamenEinlesen (baum :TBinTree);
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  FVerwaltung: TFVerwaltung;

implementation

{$R *.DFM}
procedure TFVerwaltung.BaumAnzeigen (AktKnoten:TTreeNode; Tiefe:integer;
                                 marker:string);
var i: integer;
    Leer: string;
    Inhalt: TText;
begin
 if not (AktKnoten.isempty)
    then begin
      BaumAnzeigen (AktKnoten.ReadRightNode,Tiefe+10,'n: ');
      Leer := '';
      For i := 1 to Tiefe do
        Leer := Leer + '  ';
      Listbox1.items.add (leer+marker+TText(AktKnoten.ReadValue).GetText);
      BaumAnzeigen (AktKnoten.ReadLeftNode,Tiefe+10,'j: ');
    end
end;

procedure TFVerwaltung.rate(baum:TBinTree);
var mldg,alterName : String;
begin
   if baum.isLeaf then
      begin
        alterName:=TText(baum.ReadElement).GetText;
        mldg := 'Handelt es sich um '+ alterName;
        mldg := mldg+' ?';
        if MessageDlg(mldg, mtInformation, [mbYes, mbNo], 0) = mrYes
        then
           MessageDlg('Da siehst Du, wie  i n t e l l i g e n t  Computer sind!!',mtInformation,[mbok,mbcancel],0)
        else
           neuenNamenEinlesen(baum)
      end
   else
       if MessageDlg(TText(baum.ReadElement).GetText,
           mtInformation, [mbYes, mbNo], 0) = mrYes
        then begin Baum.Left;  rate (baum) end
        else begin Baum.Right; rate (baum) end
end;

procedure TFVerwaltung.neuenNamenEinlesen (baum :TBinTree);
var mldg,neuerName,alterName,neueFrage : String;
    inhalt,inhaltAlt,inhaltNeu : TText;
begin
   alterName := TText(baum.ReadElement).GetText;
             eingabe:=TFeingabe.create(FVerwaltung);
             eingabe.label1.caption:='';
             eingabe.label2.caption:='Wie heit die/der Lehrer/in,'+
                                     'den/die ich nicht erraten habe?' ;
             eingabe.showmodal;
             neuerName:=eingabe.getinhalt;

             eingabe:=TFeingabe.create(FVerwaltung);
             eingabe.label1.caption:='Gib bitte eine Frage ein, welche die Personen';
             eingabe.label2.caption:=altername +' und '+neuerName+' unterscheidet!';
             eingabe.showmodal;
             neueFrage:=eingabe.getinhalt;

             inhalt:=TText.create(neueFrage);
             baum.WriteElement(inhalt);

             inhaltalt:=TText.create(altername);

             inhaltneu:=TText.create(neuername);

             mldg := 'Mu die Frage '+neueFrage;
             mldg := mldg + ' fr '+neuername+' mit  JA   beantwortet werden??';
             if MessageDlg(mldg, mtInformation, [mbYes, mbNo], 0) = mrYes then
                begin
                   baum.AddLeft (inhaltNeu);
                   baum.AddRight(inhaltAlt)
                end
              else
                begin
                   baum.AddLeft (inhaltAlt);
                   baum.AddRight(inhaltNeu)
                end;
             Listbox1.items.add('------------------------');
             wissensbaum.reset;
             BaumAnzeigen(wissensbaum.ReadRoot,0,'')
end; (* of proc neuenNamenEinlesen *)

procedure TFVerwaltung.FormCreate(Sender: TObject);
var inhalt:TText;
    lbaum,rbaum:TTreeNode;
begin
    inhalt := TText.create('Ist es eine Lehrerin ??');
    wissensbaum := TBinTree.create(inhalt);
    

    inhalt := TText.create('Frau Dreseler');
    wissensbaum.AddLeft(inhalt);

    inhalt := TText.create('Herr Kubitz');
    wissensbaum.AddRight(inhalt);
    BaumAnzeigen(wissensbaum.ReadRoot,0,'')
end;

procedure TFVerwaltung.BtRatenClick(Sender: TObject);
begin
   wissensbaum.reset;
   rate(wissensbaum)
end;

procedure TFVerwaltung.BtGrundwissenClick(Sender: TObject);
begin
  wissensbaum.free;
  Listbox1.items.clear;
  FormCreate(sender)
end;

procedure TFVerwaltung.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   wissensbaum.destroy
end;

end.
